// ====================================================================
// SSclassGrader.cpp
// Written by:
// Last modified:
//
// Decription:   Do NOT distribute to students
//
// ====================================================================
#include <iostream>
#include <fstream>
#include <sstream>       // for use of std::stringstream
#include "SSclass.h"

using namespace std;

// ====================================================================
// Global Function Prototype Declaration
// ====================================================================
int BaseTest(string filename, long &pts, long &total);


// ====================================================================
// main function - it all begins here
// argc = number of arguments on the command line when program was run
// argv = an array of strings, argv[0] = executable name
//                             argv[1] = first parameter to the program
//                             argv[2] = second parameter
//                                 :
//                             argv[argc-1] = last parameter
//
// argc = argument count, argv = argument vector (of strings)
// ====================================================================
int main(int argc, char * argv[])
{
	long totalPoints = 0;
	long points      = 0;
	
   // ---------------------------------------- Initialization
   // Setup what file to use an input, 
   // allowing for user specification, 
   // or just a default file
   string dataFilename = "baseTestData.txt";
   if (argc >= 2)
   {
      dataFilename = argv[1];
   }
   
   // ------------- Test Base Case
   BaseTest(dataFilename, points, totalPoints);
   cout << "   BaseTest score: " << points << " out of " << totalPoints << endl;


   // ---------------------------------------- Final Score
   cout << "\n\n==================================================================\n";
   cout << "Final Score: " << points << " out of " << totalPoints << endl;

   // ---------------------------------------- Cleanup
   cout << "\nProgram ends.\n";
   return 0;
}

// ====================================================================
// ====================================================================
int BaseTest(string filename, long &pts, long &total)
{
   // Create an instantiation of the new class, send it the name of the file to get data from
   SSclass dataHolder(filename);
   
   total += 10;
   pts += 10;    // constructor didn't crash, give points
   
   total +=5;
   int dsize = dataHolder.DataSize();
   if ( dsize == 16)
   {
	   cout << "DataSize() pass\n";
	   pts += 5;
   }
   else { cout << "DataSize() FAILED with value of " << dsize << endl; }
   
   // ---------------------------------------- operator <<
   string expectedStr[50]; 
   int esSize = 0;
   expectedStr[esSize++] = filename + ":\n65.3 12.56 -34.123 9000 4321\n123.45 999.999 777 34.5678 -1234\n17 -45 23456 231 9846\n1981\nEOD\n";
   expectedStr[esSize++] = filename + ": \n65.3 12.56 -34.123 9000 4321\n123.45 999.999 777 34.5678 -1234\n17 -45 23456 231 9846\n1981\nEOD\n";
   expectedStr[esSize++] = filename + ":\n65.3 12.56 -34.123 9000 4321\n123.45 999.999 777 34.5678 -1234\n17 -45 23456 231 9846\n1981\nEOD";
   expectedStr[esSize++] = filename + ": \n65.3 12.56 -34.123 9000 4321\n123.45 999.999 777 34.5678 -1234\n17 -45 23456 231 9846\n1981\nEOD";
   expectedStr[esSize++] = filename + ":\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \nEOD\n";
   expectedStr[esSize++] = filename + ":\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \nEOD \n";
   expectedStr[esSize++] = filename + ": \n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \nEOD \n";
   expectedStr[esSize++] = filename + ":\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \nEOD";
   // begin errors - pts off - missing colon
   int allPointsIndex = esSize;
   expectedStr[esSize++] = filename + "\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \nEOD\n";
   //                pts off - missing EOD
   expectedStr[esSize++] = filename + ":\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \n";
   
   // begin multiple errors - pts off - missing colon and missing EOD and error in filename:
   int mediumCreditIndex = esSize;
   expectedStr[esSize++]  = filename + "\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 \n";
   expectedStr[esSize++]  = filename + "\n65.3 12.56 -34.123 9000 4321 \n123.45 999.999 777 34.5678 -1234 \n17 -45 23456 231 9846 \n1981 ";
   expectedStr[esSize++] = filename + "\n65.3 12.56 -34.123 9000 4321\n123.45 999.999 777 34.5678 -1234\n17 -45 23456 231 9846\n1981\n";
   expectedStr[esSize++] = filename + "\n65.3 12.56 -34.123 9000 4321\n123.45 999.999 777 34.5678 -1234\n17 -45 23456 231 9846\n1981";

   // begin multiple errors - pts off - just has filename: (somewhere)
   int minCreditIndex = esSize;
   expectedStr[esSize++] = filename + ":\n";
   expectedStr[esSize++] = filename + ":";
   expectedStr[esSize++] = filename + ": ";
   expectedStr[esSize++] = filename + ": \n";

   // Index 4 above was the way the PDF reads to output stuff -- space after every number

   stringstream ss;
   ss << dataHolder;     // effectively: cout << dataHolder;

   int testIndex = 0;
   bool passCOUT = false;
   ///stringstream testStream;
   while ( (passCOUT == false) && (testIndex < esSize))
   {
      ///if ( ss.str() == testStream.str() )
      if ( ss.str() == expectedStr[testIndex] )
      {
         passCOUT = true;
      }
      if (testIndex >= minCreditIndex)   // check for substring match
      {
		  string temp = ss.str();
          size_t found = temp.find(expectedStr[testIndex]);
          if (found == 0)        // filename should start at position 0
          {                      // use !=std::string::npos if just want found 'somewhere'
			  passCOUT = true;
		  }
	  }
      testIndex++;
      
  } // end while
  
  if (true == passCOUT) { testIndex--; }   // as we added one to many
  
  total += 12;
  if ((true == passCOUT) && (testIndex < allPointsIndex))  // all right
  {
	  cout << "COUT pass on testIndx = " << testIndex << endl;
	  cout << "output is\n[\n";
	  cout << dataHolder << "\n]\n";
	  pts += 12;
  }
  else if ((true == passCOUT) && (testIndex < mediumCreditIndex))  // missing 1 thing
  {
	  cout << "CAUTION: cout test is hardcoded to a specific file content\n"; 
	  cout << "COUT fails with:" << "\n[\n" << ss.str() << "\n]\n";
	  cout << "but gets points with testIndx = " << testIndex << endl;
	  pts += 8;
  }
  else if ((true == passCOUT) && (testIndex < minCreditIndex))   // missing 2 things
  {
	  cout << "CAUTION: cout test is hardcoded to a specific file content\n"; 
	  cout << "COUT fails with:" << "\n[\n" << ss.str() << "\n]\n";
	  cout << "but gets points with testIndx = " << testIndex << endl;
	  pts += 6;
  }
  else if (true == passCOUT)   // had just the filename:
  {
	  cout << "CAUTION: cout test is hardcoded to a specific file content\n"; 
	  cout << "COUT fails with:" << "\n[\n" << ss.str() << "\n]\n";
	  cout << "but gets points with testIndx = " << testIndex << endl;
	  pts += 2;
  }
  else 
  {
	  cout << "CAUTION: cout test is hardcoded to a specific file content\n"; 
	  cout << "COUT fails with:" << "\n[\n" << ss.str() << "\n]\n";
  }
   
   
   // ---------------------------------------- Linear Search 65.3 is
   total += 7;
   if (dataHolder.FindValue(65.3) == true)
   {
	   cout << "FindValue 65.3 pass\n";
	   pts += 7;
   }
   else { cout << "FindValue 65.3 FAILED\n"; }
   
   // ---------------------------------------- Linear Search -23.8 is not
   total += 7;
   if (dataHolder.FindValue(-23.8) == false)
   {
	   cout << "FindValue -23.8 pass\n";
	   pts += 7;
   }
   else { cout << "FindValue -23.8 FAILED\n"; }

   // ---------------------------------------- Linear Search 45321 is not
   total += 7;
   if (dataHolder.FindValue(45321) == false)
   {
	   cout << "FindValue 45321 pass\n";
	   pts += 7;
   }
   else { cout << "FindValue 45321 FAILED\n"; }

   // ---------------------------------------- Linear Search 9846 is 
   total += 7;
   if (dataHolder.FindValue(9846) == true)
   {
	   cout << "FindValue 9846 pass\n";
	   pts += 7;
   }
   else { cout << "FindValue 9846 FAILED\n"; }

   cout << "   score: " << pts << " out of " << total << endl;


   // ---------------------------------------- Sorting Test
   cout << "Sorting...\n";
   dataHolder.SortData();
   cout << "... end sorting\n\n";
   total += 10;
   pts += 10;    // didn't crash

   cout << "   score: " << pts << " out of " << total << endl;

   // ---------------------------------------- Searching Test  999.999 with var
   total += 7;
   float valueToFind = 999.999;
   if (true == dataHolder.FindValue(valueToFind))
   {
      cout << "   Value = " << valueToFind << " was found --- pass.\n";
      pts +=7;
   }
   else
   {
      cout << "   Value = " << valueToFind << " NOT found --- FAIL.\n";
   }
   cout << "   score: " << pts << " out of " << total << endl;

   // ---------------------------------------- Searching Test  is not float with var
   total += 7;
   float v2 = 132.45;
   if (true == dataHolder.FindValue(v2))
   {
      cout << "   Value = " << v2 << " was found --- FAIL.\n";
   }
   else
   {
      cout << "   Value = " << v2 << " NOT found --- pass.\n";
      pts += 7;
   }
   cout << "   score: " << pts << " out of " << total << endl;

   // ---------------------------------------- Searching Test  last in file with var
   total += 7;
   float v3 = 1981;
   if (true == dataHolder.FindValue(v3))
   {
      cout << "   Value = " << v3 << " was found --- pass.\n";
      pts +=7;
   }
   else
   {
      cout << "   Value = " << v3 << " NOT found --- FAIL.\n";
   }
   cout << "   score: " << pts << " out of " << total << endl;

   // ---------------------------------------- Searching Test  is in int file with var
   total += 7;
   float v4 = -45;
   if (true == dataHolder.FindValue(v4))
   {
      cout << "   Value = " << v4 << " was found --- pass.\n";
      pts +=7;
   }
   else
   {
      cout << "   Value = " << v4 << " NOT found --- FAIL.\n";
   }
   cout << "   score: " << pts << " out of " << total << endl;

   // ---------------------------------------- Searching Test  is not int with var
   total += 7;
   float v5 = -666;
   if (true == dataHolder.FindValue(v5))
   {
      cout << "   Value = " << v5 << " was found --- FAIL.\n";
   }
   else
   {
      cout << "   Value = " << v5 << " NOT found --- pass.\n";
      pts +=7;
   }
   cout << "   score: " << pts << " out of " << total << endl;

   return pts;

}

// ====================================================================
// ====================================================================
// end of file
